Commit | Line | Data |
---|---|---|
765f2bf0 | 1 | #!/bin/bash |
b2441318 | 2 | # SPDX-License-Identifier: GPL-2.0 |
dcecc6c7 RD |
3 | # Disassemble the Code: line in Linux oopses |
4 | # usage: decodecode < oops.file | |
5 | # | |
6 | # options: set env. variable AFLAGS=options to pass options to "as"; | |
7 | # e.g., to decode an i386 oops on an x86_64 system, use: | |
8 | # AFLAGS=--32 decodecode < 386.oops | |
d72e720a | 9 | # PC=hex - the PC (program counter) the oops points to |
dcecc6c7 | 10 | |
765f2bf0 BP |
11 | faultlinenum=1 |
12 | ||
fa220d89 | 13 | cleanup() { |
5358db0b | 14 | rm -f $T $T.s $T.o $T.oo $T.aa $T.dis |
fa220d89 RD |
15 | exit 1 |
16 | } | |
17 | ||
18 | die() { | |
19 | echo "$@" | |
20 | exit 1 | |
21 | } | |
22 | ||
23 | trap cleanup EXIT | |
24 | ||
25 | T=`mktemp` || die "cannot create temp file" | |
dcecc6c7 | 26 | code= |
7e68b361 | 27 | cont= |
dcecc6c7 RD |
28 | |
29 | while read i ; do | |
30 | ||
31 | case "$i" in | |
32 | *Code:*) | |
33 | code=$i | |
7e68b361 AS |
34 | cont=yes |
35 | ;; | |
36 | *) | |
37 | [ -n "$cont" ] && { | |
38 | xdump="$(echo $i | grep '^[[:xdigit:]<>[:space:]]\+$')" | |
39 | if [ -n "$xdump" ]; then | |
40 | code="$code $xdump" | |
41 | else | |
42 | cont= | |
43 | fi | |
44 | } | |
dcecc6c7 RD |
45 | ;; |
46 | esac | |
47 | ||
48 | done | |
49 | ||
50 | if [ -z "$code" ]; then | |
fa220d89 | 51 | rm $T |
dcecc6c7 RD |
52 | exit |
53 | fi | |
54 | ||
55 | echo $code | |
56 | code=`echo $code | sed -e 's/.*Code: //'` | |
57 | ||
5358db0b | 58 | width=`expr index "$code" ' '` |
b396aa03 | 59 | width=$((($width-1)/2)) |
5358db0b RV |
60 | case $width in |
61 | 1) type=byte ;; | |
62 | 2) type=2byte ;; | |
63 | 4) type=4byte ;; | |
64 | esac | |
65 | ||
c5cfb62f MZ |
66 | if [ -z "$ARCH" ]; then |
67 | case `uname -m` in | |
68 | aarch64*) ARCH=arm64 ;; | |
69 | arm*) ARCH=arm ;; | |
70 | esac | |
71 | fi | |
72 | ||
d72e720a | 73 | # Params: (tmp_file, pc_sub) |
5358db0b | 74 | disas() { |
d72e720a BP |
75 | t=$1 |
76 | pc_sub=$2 | |
77 | ||
78 | ${CROSS_COMPILE}as $AFLAGS -o $t.o $t.s > /dev/null 2>&1 | |
5358db0b | 79 | |
b396aa03 RV |
80 | if [ "$ARCH" = "arm" ]; then |
81 | if [ $width -eq 2 ]; then | |
5358db0b RV |
82 | OBJDUMPFLAGS="-M force-thumb" |
83 | fi | |
84 | ||
d72e720a | 85 | ${CROSS_COMPILE}strip $t.o |
5358db0b RV |
86 | fi |
87 | ||
be9fa663 WD |
88 | if [ "$ARCH" = "arm64" ]; then |
89 | if [ $width -eq 4 ]; then | |
90 | type=inst | |
91 | fi | |
92 | ||
d72e720a | 93 | ${CROSS_COMPILE}strip $t.o |
be9fa663 WD |
94 | fi |
95 | ||
d72e720a BP |
96 | if [ $pc_sub -ne 0 ]; then |
97 | if [ $PC ]; then | |
98 | adj_vma=$(( $PC - $pc_sub )) | |
99 | OBJDUMPFLAGS="$OBJDUMPFLAGS --adjust-vma=$adj_vma" | |
100 | fi | |
101 | fi | |
102 | ||
103 | ${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $t.o | \ | |
104 | grep -v "/tmp\|Disassembly\|\.text\|^$" > $t.dis 2>&1 | |
5358db0b RV |
105 | } |
106 | ||
765f2bf0 BP |
107 | # Match the maximum number of opcode bytes from @op_bytes contained within |
108 | # @opline | |
109 | # | |
110 | # Params: | |
111 | # @op_bytes: The string of bytes from the Code: line | |
112 | # @opline: The disassembled line coming from objdump | |
113 | # | |
114 | # Returns: | |
115 | # The max number of opcode bytes from the beginning of @op_bytes which match | |
116 | # the opcode bytes in the objdump line. | |
117 | get_substr_opcode_bytes_num() | |
118 | { | |
119 | local op_bytes=$1 | |
120 | local opline=$2 | |
121 | ||
122 | local retval=0 | |
123 | substr="" | |
124 | ||
125 | for opc in $op_bytes; | |
126 | do | |
127 | substr+="$opc" | |
128 | ||
129 | # return if opcode bytes do not match @opline anymore | |
130 | if ! echo $opline | grep -q "$substr"; | |
131 | then | |
132 | break | |
133 | fi | |
134 | ||
135 | # add trailing space | |
136 | substr+=" " | |
137 | retval=$((retval+1)) | |
138 | done | |
139 | ||
140 | return $retval | |
141 | } | |
142 | ||
143 | # Return the line number in objdump output to where the IP marker in the Code: | |
144 | # line points to | |
145 | # | |
146 | # Params: | |
147 | # @all_code: code in bytes without the marker | |
148 | # @dis_file: disassembled file | |
149 | # @ip_byte: The byte to which the IP points to | |
150 | get_faultlinenum() | |
151 | { | |
152 | local all_code="$1" | |
153 | local dis_file="$2" | |
154 | ||
155 | # num bytes including IP byte | |
156 | local num_bytes_ip=$(( $3 + 1 * $width )) | |
157 | ||
158 | # Add the two header lines (we're counting from 1). | |
159 | local retval=3 | |
160 | ||
161 | # remove marker | |
162 | all_code=$(echo $all_code | sed -e 's/[<>()]//g') | |
163 | ||
164 | while read line | |
165 | do | |
166 | get_substr_opcode_bytes_num "$all_code" "$line" | |
167 | ate_opcodes=$? | |
168 | ||
169 | if ! (( $ate_opcodes )); then | |
170 | continue | |
171 | fi | |
172 | ||
173 | num_bytes_ip=$((num_bytes_ip - ($ate_opcodes * $width) )) | |
174 | if (( $num_bytes_ip <= 0 )); then | |
175 | break | |
176 | fi | |
177 | ||
178 | # Delete matched opcode bytes from all_code. For that, compute | |
179 | # how many chars those opcodes are represented by and include | |
180 | # trailing space. | |
181 | # | |
182 | # a byte is 2 chars, ate_opcodes is also the number of trailing | |
183 | # spaces | |
184 | del_chars=$(( ($ate_opcodes * $width * 2) + $ate_opcodes )) | |
185 | ||
186 | all_code=$(echo $all_code | sed -e "s!^.\{$del_chars\}!!") | |
187 | ||
188 | let "retval+=1" | |
189 | ||
190 | done < $dis_file | |
191 | ||
192 | return $retval | |
193 | } | |
194 | ||
dcecc6c7 RD |
195 | marker=`expr index "$code" "\<"` |
196 | if [ $marker -eq 0 ]; then | |
197 | marker=`expr index "$code" "\("` | |
198 | fi | |
199 | ||
846442c8 | 200 | touch $T.oo |
dcecc6c7 | 201 | if [ $marker -ne 0 ]; then |
765f2bf0 BP |
202 | # How many bytes to subtract from the program counter |
203 | # in order to get to the beginning virtual address of the | |
204 | # Code: | |
205 | pc_sub=$(( (($marker - 1) / (2 * $width + 1)) * $width )) | |
846442c8 AV |
206 | echo All code >> $T.oo |
207 | echo ======== >> $T.oo | |
208 | beforemark=`echo "$code"` | |
5358db0b | 209 | echo -n " .$type 0x" > $T.s |
765f2bf0 | 210 | |
5358db0b | 211 | echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s |
765f2bf0 | 212 | |
d72e720a | 213 | disas $T $pc_sub |
765f2bf0 | 214 | |
5358db0b | 215 | cat $T.dis >> $T.oo |
dcecc6c7 | 216 | |
765f2bf0 BP |
217 | get_faultlinenum "$code" "$T.dis" $pc_sub |
218 | faultlinenum=$? | |
219 | ||
220 | # and fix code at-and-after marker | |
dcecc6c7 | 221 | code=`echo "$code" | cut -c$((${marker} + 1))-` |
765f2bf0 BP |
222 | |
223 | rm -f $T.o $T.s $T.dis | |
dcecc6c7 | 224 | fi |
765f2bf0 | 225 | |
846442c8 AV |
226 | echo Code starting with the faulting instruction > $T.aa |
227 | echo =========================================== >> $T.aa | |
75e2f715 | 228 | code=`echo $code | sed -e 's/\r//;s/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'` |
5358db0b | 229 | echo -n " .$type 0x" > $T.s |
dcecc6c7 | 230 | echo $code >> $T.s |
d72e720a | 231 | disas $T 0 |
5358db0b | 232 | cat $T.dis >> $T.aa |
846442c8 | 233 | |
e08df079 | 234 | cat $T.oo | sed -e "${faultlinenum}s/^\([^:]*:\)\(.*\)/\1\*\2\t\t<-- trapping instruction/" |
846442c8 AV |
235 | echo |
236 | cat $T.aa | |
237 | cleanup |